# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at https://mozilla.org/MPL/2.0/.
import asyncio
import copy
import json
import math
import mimetypes
from dataclasses import field, dataclass
from datetime import datetime, timezone
from logging import getLogger
from pathlib import Path
from tempfile import TemporaryDirectory

from ryax.worker.application.tasks_service import TasksService
from ryax.worker.domain.deployment.deployment_entities import Deployment
from ryax.worker.domain.execution.execution_exceptions import (
    ExecutionIODefinitionNotFoundError,
)
from ryax.worker.domain.execution.execution_entities import Execution, IOType
from ryax.worker.domain.execution.execution_events import (
    InitTaskCommand,
    TaskNewLogLinesEvent,
    TaskCompletedEvent,
)
from ryax.worker.domain.execution.execution_service import IExecutionService
from ryax.worker.domain.execution.execution_values import TaskState
from ryax.common.domain.internal_messaging.message_bus import IMessageBus
from ryax.worker.domain.ssh.ssh_connection_helper import (
    ISshConnectionHelper,
    SSHCredentials,
)
from ryax.common.domain.storage.storage_service import IStorageService
from ryax.worker.infrastructure.ssh.ssh_connection_helper import SshConnectionHelper

logger = getLogger(__name__)


class UnsupportedIOType(Exception):
    pass


class ExecutionInitializationError(Exception):
    pass


class SlurmExecutionException(Exception):
    pass


class AddonHpcConfigurationException(Exception):
    pass


@dataclass
class SSHV1ExecutionService(IExecutionService):
    storage_service: IStorageService
    message_bus: IMessageBus
    tasks_service: TasksService
    ryax_cache_dir: Path
    default_credentials: SSHCredentials
    # dictionary to hold the last_printed_line per log
    last_printed_line: int = field(default=1)
    ssh_connection: ISshConnectionHelper | None = None
    slurm_sbatch_header: str | None = None

    def _get_sif_image(self, action_deployment: Deployment) -> Path:
        action_version = action_deployment.version
        action_name = action_deployment.name
        return self.ryax_cache_dir / f"{action_name}_{action_version}.sif"

    def _get_execution_dir(
        self,
        execution: Execution,
    ) -> Path:
        execution_id = execution.id
        deployment_id = execution.deployment_id
        return self.ryax_cache_dir / f"{deployment_id}_{execution_id}"

    def _get_input_execution_dir(
        self,
        execution: Execution,
    ) -> Path:
        return self._get_execution_dir(execution) / "inputs"

    def _get_output_execution_dir(
        self,
        execution: Execution,
    ) -> Path:
        return self._get_execution_dir(execution) / "outputs"

    def _make_script(self, content: str, script_file: Path) -> Path:
        with open(script_file, "w+") as f:
            f.write(content)
        return script_file

    def _create_sbatch(
        self,
        execution: Execution,
        deployment: Deployment,
        slurm_sbatch_header: str,
        local_dir: Path,
        remote_home_cache_dir: Path,
        custom_script: str | None = None,
    ) -> tuple[Path, Path]:
        """
        Create a minimal sbatch using the slurm_sbatch_header received
        as a parameter.
        The sbatch script should call the handler.py after loading the
        inputs from a dict.
        """
        if custom_script is None:
            run_script = "##### RYAX AUTOGENERATED SCRIPT #####\nsrun $RYAX_PREFIX/slurm_wrapper.sh"
        else:
            input_env_list = []
            for input_name, input_value in execution.inputs.items():
                try:
                    input_def = execution.get_input_definition(input_name)
                    if input_def.type == IOType.FILE:
                        input_env_list.append(
                            f"export {input_name}=$RYAX_INPUTS_DIR/{Path(input_value).name}"
                        )
                    elif input_def.type == IOType.DIRECTORY:
                        input_env_list.append(
                            f"python3 -c \"import shutil; shutil.unpack_archive('$RYAX_INPUTS_DIR/{input_value}', '/tmp/{Path(input_value).stem}')\""
                        )
                        input_env_list.append(
                            f"export {input_name}=/tmp/{Path(input_value).stem}"
                        )
                    else:
                        input_env_list.append(f"export {input_name}={input_value}")
                except ExecutionIODefinitionNotFoundError:
                    logger.error(
                        f"Error while generating inputs : {input_name} with value {input_value}"
                    )
                    raise

            inputs_in_env_vars = "\n".join(input_env_list)
            output_list = [f"{output.name}" for output in execution.get_outputs()]
            output_list_files = [
                f"{output.name}" for output in execution.get_outputs(IOType.FILE)
            ]
            output_list_directories = [
                f"{output.name}" for output in execution.get_outputs(IOType.DIRECTORY)
            ]
            run_script = (
                f"""##### RYAX CUSTOM SCRIPT BY USER #####
cd $RYAX_PREFIX/home
export RYAX_INPUTS_FILE=${{RYAX_PREFIX%/}}/inputs.json
export RYAX_INPUTS_DIR=${{RYAX_PREFIX%/}}/inputs
export RYAX_OUTPUTS_FILE=${{RYAX_PREFIX%/}}/outputs.json
export RYAX_OUTPUTS_DIR=${{RYAX_PREFIX%/}}/outputs

# inject inputs
{inputs_in_env_vars}

# export outputs on exit
export_outputs() {{
    python3 -c "
import shutil
import os
import json
from pathlib import Path
    
output_dict = dict()
output_dir = Path(os.environ['RYAX_OUTPUTS_DIR'])

for output_name in {output_list}:
    output_value = os.environ.get(output_name)
    if output_value is not None:
        output_dict[output_name] = output_value
        
for output_name in {output_list_directories}:
    output_value = os.environ.get(output_name)
    if output_value is not None:
        output_archive = output_dir / Path(output_value).name
        shutil.make_archive(str(output_archive), 'zip', root_dir=output_value)
        # Always get path relative to output dir
        output_dict[output_name] = str(output_archive) + '.zip'
        
for output_name in {output_list_files}:
    output_value = os.environ.get(output_name)
    if output_value is not None:
        shutil.copy(output_value, str(output_dir))
        # Get path relative to outputs dir
        output_dict[output_name] = str(output_dir / Path(output_value).name)

with open(os.environ['RYAX_OUTPUTS_FILE'], 'w') as output_file:
    json.dump(output_dict, output_file)
"
}}
trap export_outputs EXIT
"""
                + custom_script
            )

        sbatch_script = f"""{slurm_sbatch_header}
##### RYAX INJECTED ENVIRONMENT VARIABLES #####
export RYAX_PREFIX=${{HOME%/}}/{self._get_execution_dir(execution)}
export RYAX_CACHE_DIR={remote_home_cache_dir}
export RYAX_HOME=${{RYAX_PREFIX%/}}/home
export RYAX_ACTION_IMG=${{HOME%/}}/{self._get_sif_image(deployment)}

{run_script}
"""
        sbatch_script_file = self._make_script(
            sbatch_script, local_dir / "sbatch_script.sh"
        )
        gpu_options = ""
        if deployment.resources and deployment.resources.gpu:
            gpu_options = "--nv --nvccli"
        slurm_wrapper_script = f"""#!/bin/bash
##### RYAX INJECTED SLURM ENVIRONMENT VARIABLES #####
RYAX_ENVFILE=`mktemp -p $RYAX_PREFIX --suffix=.$SLURM_PROCID.env`
echo "Saving environment to $RYAX_ENVFILE"
env | grep SLURM > $RYAX_ENVFILE
echo "Slurm process $SLURM_PROCID running command"
singularity run {gpu_options} --no-umask --bind $RYAX_CACHE_DIR:/home/ryax/.cache  --bind $RYAX_ENVFILE:/data/default.env --bind $RYAX_HOME:/home/ryax --bind $RYAX_PREFIX:/iodir --pwd=/data $RYAX_ACTION_IMG
"""
        slurm_wrapper_script_file = self._make_script(
            slurm_wrapper_script, local_dir / "slurm_wrapper.sh"
        )

        return sbatch_script_file, slurm_wrapper_script_file

    async def _dispatch_slurm_sbatch(
        self,
        sbatch_script_file: Path,
        execution_id: str,
    ) -> str:
        logger.debug(f"Executing {sbatch_script_file}...")
        # find and save job id
        assert self.ssh_connection is not None
        execution_output = await self.ssh_connection.exec_ssh_cmd(
            f"sbatch --job-name=ryax-{execution_id} {sbatch_script_file}"
        )
        if execution_output.return_code != 0:
            logger.info("Could not launch sbatch file %s", sbatch_script_file)
            logger.info("stderr ===========>\n%s", execution_output.stderr)
            raise SlurmExecutionException(
                f"Could not run the sbatch script, for execution {execution_id} log for details: {execution_output.stderr}"
            )
        slurmjob_id = execution_output.stdout.split()[-1]
        logger.info(
            "SLURM job create for execution %s with job ID: %s",
            execution_id,
            slurmjob_id,
        )
        # Initialize execution
        return slurmjob_id

    async def get_slurmjob_state(self, job_id: str) -> str | None:
        assert self.ssh_connection is not None
        ssh_stdout, ssh_stderr, ret_code = await self.ssh_connection.exec_ssh_cmd(
            f"squeue -u {self.ssh_connection.username} -j {job_id}"
        )
        slurmjob_state = None  # default is None
        if ret_code == 0:
            try:
                slurmjob_state = (ssh_stdout.split("\n")[1]).split()[4]
            except (KeyError, IndexError):
                slurmjob_state = None
        logger.info("SLURM job %s current state: %s", job_id, slurmjob_state)
        return slurmjob_state

    async def get_log_lines(self, job_id: str) -> str:
        assert self.ssh_connection is not None
        sed_cmd = f"sed -n '{self.last_printed_line},$p' slurm-{job_id}.out"
        execution_output = await self.ssh_connection.exec_ssh_cmd(sed_cmd)
        log_lines_to_print = execution_output.stdout.split("\n")
        if execution_output.return_code == 0:
            self.last_printed_line += len(log_lines_to_print)
            return execution_output.stdout
        else:
            logger.error(
                f"Command {sed_cmd} FAILED : {job_id} (return code: {execution_output.return_code}) : \nSTDOUT {execution_output.stdout}\nSTDERR {execution_output.stderr}"
            )
            return f"Unexpected RYAX log capture failure '{sed_cmd}' for SLURM job id : {job_id} (return code: {execution_output.return_code}) : \nSTDOUT {execution_output.stdout}\nSTDERR {execution_output.stderr}"

    async def _create_dir_or_fail(self, dir_name: Path) -> None:
        assert self.ssh_connection is not None
        cmd_ret = await self.ssh_connection.exec_ssh_cmd(f"mkdir -p ./{str(dir_name)}")
        if cmd_ret.return_code != 0:
            raise ExecutionInitializationError(
                f"Error cannot create remote directory {dir_name}: {cmd_ret.stderr}"
            )

    async def _send_logs(
        self,
        log_lines: str | None,
        task_id: str | None,
    ) -> None:
        if log_lines is None or task_id is None:
            return

        await self.message_bus.handle_event(
            TaskNewLogLinesEvent(
                log_lines,
                task_id,
            )
        )

    async def run(self, execution: Execution, deployment: Deployment) -> None:
        """
        Run remotely a slurm sbatch job that will execute the action singularity image with the correct
        input parameters. Parameters of type file or directory need to be downloaded from ryax filestore
        and injected on the remote using ssh. The rest of the inputs are all in a json file also on the
        slurm cluster frontend.
        """
        addons_extra_params = deployment.addons
        self.ssh_connection = SshConnectionHelper.create_ssh_connection(
            addons_extra_params.get("hpc", {}), self.default_credentials
        )
        if addons_extra_params.get("hpc") and addons_extra_params["hpc"].get(
            "slurm_args"
        ):
            self.slurm_sbatch_header = addons_extra_params["hpc"]["slurm_args"]
        else:
            # TODO use admin defined default values instead to avoid using the whole node and increase backfilling
            self.slurm_sbatch_header = f"""#!/usr/bin/env bash
#SBATCH --nodes=1
#SBATCH --partition={deployment.node_pool.name}
#SBATCH --comment='container: {deployment.container_image}, execution_id: {execution.id}'
#SBATCH --job-name={deployment.id}
"""
            if deployment.resources.cpu:
                self.slurm_sbatch_header += (
                    f"#SBATCH --cpus-per-task={math.ceil(deployment.resources.cpu)}\n"
                )
            if deployment.resources.memory:
                memory = int(deployment.resources.memory / 1024**2)
                f"#SBATCH --mem={memory}M\n"
            if deployment.resources.time:
                f"#SBATCH --time={int(deployment.resources.time / 60)}\n"
            if deployment.resources.gpu:
                f"#SBATCH --gres=gpu:{int(deployment.resources.gpu)}\n"

        ###################################
        # INIT PHASE
        ###################################
        # Get timer when execution start
        logger.info("Starting ssh slurm execution...")
        logger.info("Starting Execution %s", execution.id)

        # Test that variable self.ssh was initialized
        assert self.ssh_connection is not None

        # Get the name of directories for this execution
        execution_dir = self._get_execution_dir(execution)
        execution_input_dir = self._get_input_execution_dir(execution)
        remote_home_cache_dir = self.ryax_cache_dir / "home/ryax/.cache"
        execution_output_dir = self._get_output_execution_dir(execution)

        # Create remote directory for this execution, it is mandatory that this directory is available on all nodes
        await self._create_dir_or_fail(self._get_execution_dir(execution) / "home")

        # Create remote directory for this execution, it is mandatory that this directory is available on all nodes
        await self._create_dir_or_fail(self.ryax_cache_dir / "home/ryax/.cache")

        # Create input and output sub directories remotely
        logger.info(f"Creating remote input directory : {execution_input_dir}...")
        await self.ssh_connection.exec_ssh_cmd(f"mkdir -p ./{execution_input_dir}")
        logger.info(f"Creating remote output directory : {execution_output_dir}...")
        await self.ssh_connection.exec_ssh_cmd(f"mkdir -p ./{execution_output_dir}")

        ###################################
        # PREPARE INPUT PHASE
        ###################################
        # Create local input directory for this execution
        with TemporaryDirectory() as execution_input_dir_local:
            # For every input handle transfer when type is file or directory
            input_dict = copy.deepcopy(execution.inputs)
            for input_name, input_value in execution.inputs.items():
                try:
                    action_input = execution.get_input_definition(input_name)
                    input_type = action_input.type
                    if input_type is None:
                        raise UnsupportedIOType(
                            f"Error while processing input {input_name}: type is not set {deployment.id}"
                        )
                    elif input_type in (IOType.FILE, IOType.DIRECTORY):
                        # TODO check if the previous executions left a directory with its outputs,
                        #  if yes take the files from there instead
                        # Get file from the stored_file service
                        with await self.storage_service.read(
                            input_value
                        ) as output_file:
                            data = output_file.read()
                            filename = Path(input_dict[input_name]).name
                            input_dict[input_name] = execution_input_dir / filename

                            # Copy file content locally to execution_directory
                            with open(
                                Path(execution_input_dir_local) / filename, "wb"
                            ) as prepared_out_file:
                                prepared_out_file.write(data)

                            await self.ssh_connection.put_ssh_file(
                                Path(execution_input_dir_local) / filename,
                                input_dict[input_name],
                            )

                        input_dict[input_name] = str(Path("/iodir/inputs") / filename)

                        logger.info(
                            f"Adding input {input_name} of type {input_type} to dict with value {input_dict[input_name]}."
                        )
                except Exception:
                    logger.info(
                        f"Parameter {input_name} was injected because of the addon with value {input_value}, ignoring"
                    )

            logger.info(f"Copying inputs json : {json.dumps(input_dict)}")
            with open(
                Path(execution_input_dir_local) / "inputs.json", "w"
            ) as input_dict_file:
                input_dict_file.write(json.dumps(input_dict))
            await self.ssh_connection.put_ssh_file(
                Path(execution_input_dir_local) / "inputs.json", execution_dir
            )
            logger.info(f"Creating sbatch with header : {self.slurm_sbatch_header}...")

            custom_script = None
            if "custom_script" in addons_extra_params.get("hpc", {}):
                custom_script = addons_extra_params["hpc"]["custom_script"]

            sbatch_script_path, slurm_wrapper_script_path = self._create_sbatch(
                execution,
                deployment,
                str(self.slurm_sbatch_header),
                Path(execution_input_dir_local),
                remote_home_cache_dir,
                custom_script,
            )
            # copy sbatch_script.sh to remote
            sbatch_script_remote_path = (
                self._get_execution_dir(execution) / sbatch_script_path.name
            )
            await self.ssh_connection.put_ssh_file(
                sbatch_script_path, sbatch_script_remote_path
            )
            # copy slurm_wrapper.sh to remote, and grant execution rights
            slurm_wrapper_script_remote_path = (
                self._get_execution_dir(execution) / slurm_wrapper_script_path.name
            )
            await self.ssh_connection.put_ssh_file(
                slurm_wrapper_script_path, slurm_wrapper_script_remote_path
            )
            await self.ssh_connection.exec_ssh_cmd(
                f"chmod +x {slurm_wrapper_script_remote_path}"
            )

        ###################################
        # EXECUTE PHASE
        ###################################
        # Get a job
        try:
            job_id = await self._dispatch_slurm_sbatch(
                sbatch_script_remote_path,
                execution_id=execution.id,
            )
        except Exception:
            logger.exception("Unexpected exception during SSH SLURM job creation")
            raise

        # Start the execution
        (
            task_id,
            workflow_run_id,
        ) = await self.message_bus.handle_command(
            InitTaskCommand(
                execution_id=execution.id,
                executor_id=f"slurmjob_{job_id}",
            )
        )
        try:
            # Wait for job to start and finish, other states mean the execution is over
            deploying_states = ["PD", "CG", "CF"]
            running_states = [
                "R",
                "CD",
                "CA",
            ]
            state = await self.get_slurmjob_state(job_id)
            while state in deploying_states or state in running_states:
                await asyncio.sleep(5)
                if state in deploying_states:
                    await self._send_logs(
                        f"Slurm Job {job_id} is pending in queue (state: {state})\n",
                        task_id,
                    )
                else:
                    lines_to_print = await self.get_log_lines(
                        job_id,
                    )
                    await self._send_logs(lines_to_print, task_id)
                state = await self.get_slurmjob_state(job_id)
        except (Exception, asyncio.CancelledError, asyncio.TimeoutError):
            # cancel the job if running
            logger.exception(
                f"Unexpected exception during SSH SLURM job execution: canceling job {job_id}"
            )
            cancel_ret = await self.ssh_connection.exec_ssh_cmd(f"scancel {job_id}")
            if cancel_ret.return_code != 0:
                error_message = f"Fail to cancel job {job_id}: STDOUT: {cancel_ret.stdout} STDERR: {cancel_ret.stderr}"
                logger.error(error_message)
                if task_id is not None:
                    await self._send_logs(
                        error_message,
                        task_id,
                    )
            raise

        lines_to_print = await self.get_log_lines(
            job_id,
        )
        await self._send_logs(
            lines_to_print,
            task_id,
        )
        if not (state is None or state == "CD"):
            raise SlurmExecutionException(
                f"The Slurm job do not completed properly. Current state is : {state}"
            )

        # Detect error because the slurmjob finished however the execution output.json dict is not there
        return_statement = await self.ssh_connection.exec_ssh_cmd(
            f"ls -1 {execution_dir}/outputs.json"
        )
        if return_statement[2] != 0:
            raise SlurmExecutionException(
                f"Slurm job finished but output dict not exported, check on {self._get_execution_dir(execution)}"
            )

        ###################################
        # RETRIEVE OUTPUT PHASE
        ###################################
        # Get output dict ./{self.get_execution_dir(execution)}/outputs.json from remote
        with TemporaryDirectory() as temp_dir:
            await self.ssh_connection.get_ssh_file(
                Path(execution_dir) / "outputs.json",
                Path(temp_dir) / "outputs.json",
            )

            with open(Path(temp_dir) / "outputs.json") as json_output:
                output_dict = json.load(json_output)
            # Handle null on outputs.json file as an empty output dict
            if output_dict is None:
                output_dict = {}

            # For all outputs of type file or directory, need to copy from local to filestore
            output_files: list[TaskCompletedEvent.OutputFile] = []
            for output_name, output_value in output_dict.items():
                # try:
                output_type = execution.get_output_definition(output_name)
                if output_type is None:
                    raise SlurmExecutionException(
                        f"Error while processing output {output_name}: type is not set {execution.id}"
                    )
                # Directory and file is handled the same because directories are .zip files
                elif output_type.type in (IOType.FILE, IOType.DIRECTORY):
                    logger.info(
                        f"Adding output {output_name} of type {output_type.type} to dict."
                    )
                    remote_file = Path(execution_output_dir) / Path(output_value).name
                    local_file = Path(temp_dir) / Path(output_value).name
                    await self.ssh_connection.get_ssh_file(remote_file, local_file)
                    size = local_file.stat().st_size
                    mimetype, encoding = mimetypes.guess_type(local_file)
                    file_path = self.storage_service.generate_file_path(local_file.name)
                    with open(local_file, "rb") as tmp_file:
                        await self.storage_service.write(file_path, tmp_file)
                    output_files.append(
                        TaskCompletedEvent.OutputFile(
                            output_name=output_name,
                            file_path=file_path,
                            mimetype=mimetype,
                            size_in_bytes=size,
                            encoding=encoding,
                        )
                    )
                    output_dict[output_name] = file_path

            # Send message containing all outputs
            await self.message_bus.handle_event(
                TaskCompletedEvent(
                    id=task_id,
                    outputs=output_dict,
                    output_files=output_files,
                    status=TaskState.SUCCESS,
                    end_time=datetime.now(timezone.utc),
                )
            )
            logger.info("Execution %s is Finished", execution.id)

        await self.ssh_connection.close()
